package com.connor.jd.plm.form;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;

import javax.swing.BorderFactory;
import javax.swing.DefaultCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;

import com.connor.jd.plm.table.CTMap;
import com.connor.jd.plm.table.CTable;

public class ComponentTestFrame extends JFrame {
	private String[] arr;
	private CTMap model;
	private CTable table;

	private static ComponentTestFrame instance;

	public static ComponentTestFrame getInstance(String[] row) {
		if (instance == null) {
			instance = new ComponentTestFrame(row);
		} else {
			instance.arr = row;
			instance.init();
		}
		return instance;
	}

	private ComponentTestFrame(String[] row) {
		this.arr = row;
		this.init();
	}

	private void init() {
		this.setTitle("Ŀ");
		this.setPreferredSize(new Dimension(700, 500));
		this.setResizable(true);
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

		Container container = this.getContentPane();
		container.setLayout(new BorderLayout());

		model = new CTMap(10, 7);
		model.setValueAt("", 0, 0);
		model.setValueAt("Ʒ", 0, 1);
		model.setValueAt("Ŀ", 0, 2);
		model.setValueAt("ʱ", 0, 3);
		model.setValueAt("Ʒ", 0, 4);
		model.setValueAt("", 0, 5);
		model.setValueAt("Ƿѡ", 0, 6);

		table = new CTable(model) {
			@Override
			public boolean isCellEditable(int row, int col) {
				if (row == 0 || col == 0) {
					return false;
				}
				return true;
			}
		};
		table.setRowHeight(25);
		table.setBorder(BorderFactory.createLineBorder(Color.black));
		for (int i = 0; i < model.getColumnCount(); i++) {
			table.getColumnModel().getColumn(i).setPreferredWidth(100);
		}
		DefaultTableCellRenderer tcr1 = new DefaultTableCellRenderer() {
			// д
			@Override
			public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
					boolean hasFocus, int row, int column) {
				// TODO Auto-generated method stub

				if (value instanceof JCheckBox) {
					return (JCheckBox) value;
				}

				int maxPreferredHeight = 0;
				for (int i = 0; i < table.getColumnCount(); i++) {
					setText("" + table.getValueAt(row, i));
					setSize(table.getColumnModel().getColumn(column).getWidth(), 0);
					maxPreferredHeight = Math.max(maxPreferredHeight, getPreferredSize().height);
				}
				setBackground(Color.white);
//				if(points1.contains(new Point(row,column)))
//					setForeground(new Color(0,0,255));
//				else
				setForeground(Color.black);
				if (isSelected) {
					setBackground(new Color(0, 120, 215));
					setForeground(Color.white);
				}
				if (table.getRowHeight(row) != maxPreferredHeight) // Ϲæ
					table.setRowHeight(row, maxPreferredHeight);

				setText(value == null ? "" : value.toString());
				return this;
			}
		};
		tcr1.setHorizontalAlignment(SwingConstants.CENTER);
		table.setDefaultRenderer(Object.class, tcr1);
		table.getColumnModel().getColumn(6).setCellEditor(new DefaultCellEditor(new JCheckBox()));

		// д

		this.setVisible(true);
	}

}
